/***********************************************************************************************
 * Only this header-file has to be included in your application to use the RAYLASE TraceBuffer API.
 * Everything is included from this file.
 ***********************************************************************************************/
#ifndef _TRACEBUFFER_API_
#define _TRACEBUFFER_API_

 /* Global defines and types used in the SPICE3 API */
#include "rltbTypes.h"

/* All headers containing the API function calls are included here */
//#include "TraceBufferAPI.h"

extern "C" DLLEXPORT rltbHandle __stdcall rltbConnect( const char* hostNameOrAddress );
extern "C" DLLEXPORT rltbResult __stdcall rltbDisconnect( rltbHandle handle );
extern "C" DLLEXPORT rltbResult __stdcall rltbIsConnected( rltbHandle handle, bool* outIsConnected );

extern "C" DLLEXPORT rltbResult __stdcall rltbGetReadTimeout( rltbHandle handle, int32_t * outTimeout );
extern "C" DLLEXPORT rltbResult __stdcall rltbSetReadTimeout( rltbHandle handle, int32_t timeoutMs );

extern "C" DLLEXPORT rltbResult __stdcall rltbInitConfig( rltbTraceBufferConfig * outConfig );
extern "C" DLLEXPORT rltbResult __stdcall rltbGetConfig( rltbHandle handle, rltbTraceBufferConfig * outConfig );
extern "C" DLLEXPORT rltbResult __stdcall rltbSetConfig( rltbHandle handle, const rltbTraceBufferConfig * config );

extern "C" DLLEXPORT rltbResult __stdcall rltbClear( rltbHandle handle );
extern "C" DLLEXPORT rltbResult __stdcall rltbStart( rltbHandle handle );
extern "C" DLLEXPORT rltbResult __stdcall rltbStop( rltbHandle handle );

extern "C" DLLEXPORT rltbResult __stdcall rltbTryRead( rltbHandle handle, rltbTraceEvent * buffer, size_t index, size_t maxCount, size_t * count );
extern "C" DLLEXPORT rltbResult __stdcall rltbRead( rltbHandle handle, rltbTraceEvent * buffer, size_t index, size_t maxCount, size_t * count );

extern "C" DLLEXPORT rltbResult __stdcall rltbAcquire( rltbHandle handle, uint16_t startLabel, uint16_t endLabel, size_t * count );
extern "C" DLLEXPORT rltbResult __stdcall rltbGetAcquiredElements( rltbHandle handle, rltbTraceEvent * buffer, size_t index, size_t maxCount, size_t * count );

extern "C" DLLEXPORT rltbResult __stdcall rltbToSignedPosition( rltbTraceEvent * traceEvents, size_t count );
extern "C" DLLEXPORT int32_t __stdcall rltbToSignedPositionVal( int64_t value );

static const double rltbTickPerMicroSecond = 64.0;
static const double rltbMicroSecondPerTick = 1.0 / 64.0;

#endif // _TRACEBUFFER_API_
